#include "stdio.h"
#include "stdlib.h"
#include "io.h"
#include "alt_types.h"

/**********************************************************************************
 * This function just iterates trough input buffers and apply linear function to  *
 * each sample. Output results are stored in corresponding output buffers.        *
 **********************************************************************************/

alt_u32 linear_function_sw(alt_8  ** input_buffers,
                           alt_16 ** output_buffers,
                           alt_u16 * buffer_lengths,
                           alt_u16 number_of_buffers,
                           alt_8 param_a,
                           alt_8 param_b)
{
	alt_u32 buffer_counter, sample_counter;

	for (buffer_counter = 0; buffer_counter < number_of_buffers; buffer_counter++)
	{
		for (sample_counter = 0; sample_counter < buffer_lengths[buffer_counter]; sample_counter++)
		{
			output_buffers[buffer_counter][sample_counter] = param_a*input_buffers[buffer_counter][sample_counter] + param_b;
		}

	}

	return 0;
}
